# -*- Makefile -*-

# Copyright (C) 2002-2017 Alexander Chernov <cher@ejudge.ru> */

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

USERLIST_CLNT_CFILES=\
 userlist_clnt/admin_process.c\
 userlist_clnt/bytes_available.c\
 userlist_clnt/bin_data.c\
 userlist_clnt/change_registration.c\
 userlist_clnt/close.c\
 userlist_clnt/cnts_passwd_op.c\
 userlist_clnt/control.c\
 userlist_clnt/copy_user_info.c\
 userlist_clnt/create_member.c\
 userlist_clnt/create_user.c\
 userlist_clnt/create_user_2.c\
 userlist_clnt/delete_cookie.c\
 userlist_clnt/delete_field.c\
 userlist_clnt/delete_info.c\
 userlist_clnt/do_pass_fd.c\
 userlist_clnt/dump_database.c\
 userlist_clnt/edit_field.c\
 userlist_clnt/edit_field_seq.c\
 userlist_clnt/generate_team_passwd.c\
 userlist_clnt/get_contests.c\
 userlist_clnt/get_cookie.c\
 userlist_clnt/get_count.c\
 userlist_clnt/get_database.c\
 userlist_clnt/get_fd.c\
 userlist_clnt/get_info.c\
 userlist_clnt/get_param.c\
 userlist_clnt/get_prev_user_id.c\
 userlist_clnt/get_uid_by_pid.c\
 userlist_clnt/get_uid_by_pid_2.c\
 userlist_clnt/get_xml_by_text.c\
 userlist_clnt/import_csv_users.c\
 userlist_clnt/list_all_users.c\
 userlist_clnt/list_users.c\
 userlist_clnt/list_users_2.c\
 userlist_clnt/login.c\
 userlist_clnt/logout.c\
 userlist_clnt/lookup_cookie.c\
 userlist_clnt/lookup_user.c\
 userlist_clnt/lookup_user_id.c\
 userlist_clnt/map_contest.c\
 userlist_clnt/move_member.c\
 userlist_clnt/notify.c\
 userlist_clnt/open.c\
 userlist_clnt/pass_fd.c\
 userlist_clnt/priv_cookie.c\
 userlist_clnt/priv_cookie_login.c\
 userlist_clnt/priv_login.c\
 userlist_clnt/read_and_notify.c\
 userlist_clnt/read_notification.c\
 userlist_clnt/recover_passwd_2.c\
 userlist_clnt/recv_packet.c\
 userlist_clnt/register_contest.c\
 userlist_clnt/register_new.c\
 userlist_clnt/register_new_2.c\
 userlist_clnt/send_packet.c\
 userlist_clnt/set_cookie.c\
 userlist_clnt/set_info.c\
 userlist_clnt/set_notification_callback.c\
 userlist_clnt/set_passwd.c\
 userlist_clnt/team_cookie.c

SUPER_CLNT_CFILES=\
 super_clnt/control.c\
 super_clnt/create_contest.c\
 super_clnt/do_pass_fd.c\
 super_clnt/http_request.c\
 super_clnt/main_page.c\
 super_clnt/open.c\
 super_clnt/pass_fd.c\
 super_clnt/recv_packet.c\
 super_clnt/send_packet.c\
 super_clnt/set_param.c\
 super_clnt/simple_cmd.c

NEW_SERVER_CLNT_CFILES=\
 new_server_clnt/close.c\
 new_server_clnt/control.c\
 new_server_clnt/http_request.c\
 new_server_clnt/open.c\
 new_server_clnt/pass_fd.c\
 new_server_clnt/recv_packet.c\
 new_server_clnt/send_packet.c

REUSE_CFILES=\
 reuse/reuse_hash.c\
 reuse/reuse_mempage.c\
 reuse/reuse_xalloc.c\
 reuse/reuse_xcalloc.c\
 reuse/reuse_xexpand.c\
 reuse/reuse_xexpand2.c\
 reuse/reuse_xexpand3.c\
 reuse/reuse_xexpand4.c\
 reuse/reuse_xfree.c\
 reuse/reuse_xmalloc.c\
 reuse/reuse_xmemdup.c\
 reuse/reuse_xrealloc.c\
 reuse/reuse_xstrarrayfree.c\
 reuse/reuse_xstrdup.c\
 reuse/reuse_xstrmerge0.c\
 reuse/reuse_xstrmerge1.c\
 reuse/reuse_xstrmerge2.c\
 reuse/reuse_xstrmerge3.c

COMMON_CFILES=\
 allowed_list.c\
 archive_paths.c\
 avatar_plugin.c\
 base32.c\
 base64.c\
 bitset.c\
 bson_utils.c\
 build_support.c\
 cgi.c\
 charsets.c\
 cJSON.c\
 clarlog.c\
 cldb_plugin_file.c\
 clntutil.c\
 common_plugin.c\
 compile_packet_1.c\
 compile_packet_2.c\
 compile_packet_3.c\
 compile_packet_4.c\
 compile_packet_5.c\
 compile_packet_6.c\
 content_plugin.c\
 content_plugin_file.c\
 content_plugin_none.c\
 contests.c\
 contests_2.c\
 contest_tmpl.c\
 copyright.c\
 csv.c\
 dates_config.c\
 diff.c\
 digest_1.c\
 digest_2.c\
 digest_3.c\
 digest_4.c\
 digest_5.c\
 dos2unix_str.c\
 dwarf_parse.c\
 ej_import_packet.c\
 ejudge_cfg.c\
 ej_libzip.c\
 ej_uuid.c\
 errlog.c\
 expat_iface.c\
 external_action.c\
 filehash.c\
 filter_eval.c\
 filter_tree.c\
 html.c\
 html_checkbox.c\
 html_date_select.c\
 html_input_password.c\
 html_input_text.c\
 html_hidden.c\
 html_hyperref.c\
 html_parse.c\
 html_start_form.c\
 http_request.c\
 imagemagick.c\
 l10n.c\
 lang_config.c\
 lang_config_vis.c\
 master_html.c\
 meta_generic.c\
 mime_type.c\
 misctext.c\
 ncheck_packet.c\
 new_server_html.c\
 new_server_html_2.c\
 new_server_html_3.c\
 new_server_html_4.c\
 new_server_html_5.c\
 new_server_proto.c\
 new_server_tables.c\
 ncurses_utils.c\
 nsdb_plugin_files.c\
 nwrun_packet.c\
 opcaps.c\
 opcaps_2.c\
 packet_name.c\
 parsecfg.c\
 parsecfg_2.c\
 pathutl.c\
 plugin.c\
 polygon_packet.c\
 prepare.c\
 prepare_out.c\
 prepare_serve.c\
 prepare_dates.c\
 printing.c\
 problem_common.c\
 problem_config.c\
 problem_xml.c\
 problem_xml_2.c\
 process_stats.c\
 protocol.c\
 random.c\
 reports.c\
 rldb_plugin_file.c\
 run_common.c\
 run_inverse.c\
 runlog.c\
 runlog_import.c\
 runlog_static.c\
 runlog_xml.c\
 run_packet_4.c\
 run_packet_5.c\
 run_packet_6.c\
 send_job_packet.c\
 server_framework.c\
 serve_2.c\
 serve_state.c\
 session.c\
 sformat.c\
 shellcfg_parse.c\
 standings.c\
 stringset.c\
 super_html.c\
 super_html_2.c\
 super_html_3.c\
 super_html_4.c\
 super_html_5.c\
 super_html_6.c\
 super_html_7.c\
 super_html_8.c\
 super_http_request.c\
 super_proto.c\
 super_run_packet.c\
 super_run_status.c\
 super_serve_pi.c\
 sha.c\
 sha256.c\
 sha256utils.c\
 blowfish.c\
 t3m_dir_listener.c\
 t3m_submits.c\
 t3m_zip_packet_class.c\
 t3_packets.c\
 teamdb.c\
 teamdb_2.c\
 team_extra.c\
 team_extra_xml.c\
 testinfo.c\
 testing_report_xml.c\
 tex_dom.c\
 tex_dom_parse.c\
 tex_dom_doc.c\
 tex_dom_render.c\
 tsc.c\
 type_info.c\
 uldb_plugin_xml.c\
 userlist.c\
 userlist_bin.c\
 userlist_check.c\
 userlist_proto.c\
 userlist_xml.c\
 variant_map.c\
 varsubst.c\
 vcs.c\
 watched_file.c\
 xuser_plugin_file.c\
 zip_utils.c\
 xml_utils/attr_bool.c\
 xml_utils/attr_bool_byte.c\
 xml_utils/attr_date.c\
 xml_utils/attr_int.c\
 xml_utils/attr_long_long.c\
 xml_utils/attr_ulong.c\
 xml_utils/elem_ip_mask.c\
 xml_utils/empty_text.c\
 xml_utils/err_attrs.c\
 xml_utils/err_attr_invalid.c\
 xml_utils/err_attr_not_allowed.c\
 xml_utils/err_attr_undefined.c\
 xml_utils/err_attr_undefined_s.c\
 xml_utils/err_elem_empty.c\
 xml_utils/err_elem_invalid.c\
 xml_utils/err_elem_not_allowed.c\
 xml_utils/err_elem_redefined.c\
 xml_utils/err_elem_undefined.c\
 xml_utils/err_elem_undefined_s.c\
 xml_utils/err_get_attr_name.c\
 xml_utils/err_get_elem_name.c\
 xml_utils/err_nested_elems.c\
 xml_utils/err_top_level.c\
 xml_utils/err_top_level_s.c\
 xml_utils/err_variables.c\
 xml_utils/full_cookie.c\
 xml_utils/leaf_elem.c\
 xml_utils/parse_bool.c\
 xml_utils/parse_date.c\
 xml_utils/parse_int.c\
 xml_utils/parse_ip.c\
 xml_utils/parse_ip_mask.c\
 xml_utils/unparse_bool.c\
 xml_utils/unparse_date.c\
 xml_utils/unparse_ip.c\
 xml_utils/unparse_ip_mask.c\
 xml_utils/unparse_run_status.c\
 xml_utils/unparse_text.c\
 xml_utils/xml_err.c\
 xml_utils/xml_err_a.c\
 ${REUSE_CFILES}

PLATFORM_CFILES =\
 $(ARCH)/fileutl.c\
 $(ARCH)/cr_serialize.c\
 $(ARCH)/interrupt.c\
 $(ARCH)/curtime.c\
 $(ARCH)/timestamp.c\
 $(ARCH)/ej_process.c\
 $(ARCH)/cpu.c\
 $(ARCH)/file_perms.c\
 $(ARCH)/full_archive.c\
 $(ARCH)/pollfds.c\
 $(ARCH)/startstop.c\
 $(ARCH)/sock_op_enable_creds.c\
 $(ARCH)/sock_op_get_fds.c\
 $(ARCH)/sock_op_put_fds.c\
 $(ARCH)/sock_op_get_creds.c\
 $(ARCH)/sock_op_put_creds.c\
 $(ARCH)/open_memstream.c\
 $(ARCH)/fmemopen.c\
 $(ARCH)/reuse_attachfile.c\
 $(ARCH)/reuse_checkaccess.c\
 $(ARCH)/reuse_dirname.c\
 $(ARCH)/reuse_errormsg.c\
 $(ARCH)/reuse_errorstring.c\
 $(ARCH)/reuse_findinpath.c\
 $(ARCH)/reuse_exec.c\
 $(ARCH)/reuse_getbasename.c\
 $(ARCH)/reuse_geterrorstring.c\
 $(ARCH)/reuse_getlastname.c\
 $(ARCH)/reuse_getsignalstring.c\
 $(ARCH)/reuse_getsuffix.c\
 $(ARCH)/reuse_getworkingdir.c\
 $(ARCH)/reuse_isabsolutepath.c\
 $(ARCH)/reuse_isfile.c\
 $(ARCH)/reuse_logger.c\
 $(ARCH)/reuse_makedir.c\
 $(ARCH)/reuse_makedirpath.c\
 $(ARCH)/reuse_nodename.c\
 $(ARCH)/reuse_normalize_path.c\
 $(ARCH)/reuse_rdirname.c\
 $(ARCH)/reuse_rgetbasename.c\
 $(ARCH)/reuse_rgetlastname.c\
 $(ARCH)/reuse_rgetsuffix.c\
 $(ARCH)/reuse_rgetworkingdir.c\
 $(ARCH)/reuse_setlock.c\
 $(ARCH)/reuse_sleep.c\
 $(ARCH)/reuse_substsuffix.c\
 $(ARCH)/reuse_tempnam.c\
 $(ARCH)/reuse_logger.c

CFILES=\
 clean-users.c\
 collect-emails.c\
 compile.c\
 compile-control.c\
 convert-clars.c\
 convert-runs.c\
 edit-userlist.c\
 ej-ncheck.c\
 ej-batch.c\
 ej-import-contest.c\
 ej-normalize.c\
 ej-page-gen.c\
 ej-parblock.c\
 ej-polygon.c\
 ej-super-run.c\
 ejudge-configure-compilers.c\
 ejudge-control.c\
 ejudge-setup.c\
 execute.c\
 fix-db.c\
 job-server.c\
 job-server-control.c\
 job-server-cmd.c\
 make-js-actions.c\
 new-client.c\
 new-server.c\
 new-server-cmd.c\
 new-server-control.c\
 nwrun.c\
 run.c\
 serve.c\
 serve-control.c\
 slice-userlist.c\
 struct-sizes.c\
 super-serve.c\
 super-serve-control.c\
 testinfo.c\
 userlist-server.c\
 userlist-server-control.c\
 users.c\
 unix/cpu.c\
 win32/cpu.c\
 unix/file_perms.c\
 win32/file_perms.c\
 unix/fileutl.c\
 win32/fileutl.c\
 unix/cr_serialize.c\
 win32/cr_serialize.c\
 unix/ej_process.c\
 win32/ej_process.c\
 unix/interrupt.c\
 win32/interrupt.c\
 unix/curtime.c\
 win32/curtime.c\
 unix/fmemopen.c\
 win32/fmemopen.c\
 unix/open_memstream.c\
 win32/open_memstream.c\
 unix/pollfds.c\
 win32/pollfds.c\
 unix/timestamp.c\
 win32/timestamp.c\
 unix/full_archive.c\
 win32/full_archive.c\
 unix/sock_op_enable_creds.c\
 win32/sock_op_enable_creds.c\
 unix/sock_op_get_creds.c\
 win32/sock_op_get_creds.c\
 unix/sock_op_get_fds.c\
 win32/sock_op_get_fds.c\
 unix/sock_op_put_fds.c\
 win32/sock_op_put_fds.c\
 unix/sock_op_put_creds.c\
 win32/sock_op_put_creds.c\
 unix/startstop.c\
 win32/startstop.c\
 unix/reuse_logger.c\
 win32/reuse_logger.c\
 unix/reuse_attachfile.c\
 win32/reuse_attachfile.c\
 unix/reuse_checkaccess.c\
 win32/reuse_checkaccess.c\
 unix/reuse_dirname.c\
 win32/reuse_dirname.c\
 unix/reuse_errormsg.c\
 win32/reuse_errormsg.c\
 unix/reuse_errorstring.c\
 win32/reuse_errorstring.c\
 unix/reuse_exec.c\
 win32/reuse_exec.c\
 unix/reuse_findinpath.c\
 win32/reuse_findinpath.c\
 unix/reuse_getbasename.c\
 win32/reuse_getbasename.c\
 unix/reuse_geterrorstring.c\
 win32/reuse_geterrorstring.c\
 unix/reuse_getlastname.c\
 win32/reuse_getlastname.c\
 unix/reuse_getsignalstring.c\
 win32/reuse_getsignalstring.c\
 unix/reuse_getsuffix.c\
 win32/reuse_getsuffix.c\
 unix/reuse_getworkingdir.c\
 win32/reuse_getworkingdir.c\
 unix/reuse_isabsolutepath.c\
 win32/reuse_isabsolutepath.c\
 unix/reuse_isfile.c\
 win32/reuse_isfile.c\
 unix/reuse_makedir.c\
 win32/reuse_makedir.c\
 unix/reuse_makedirpath.c\
 win32/reuse_makedirpath.c\
 unix/reuse_nodename.c\
 win32/reuse_nodename.c\
 unix/reuse_normalize_path.c\
 win32/reuse_normalize_path.c\
 unix/reuse_rdirname.c\
 win32/reuse_rdirname.c\
 unix/reuse_rgetbasename.c\
 win32/reuse_rgetbasename.c\
 unix/reuse_rgetlastname.c\
 win32/reuse_rgetlastname.c\
 unix/reuse_rgetsuffix.c\
 win32/reuse_rgetsuffix.c\
 unix/reuse_rgetworkingdir.c\
 win32/reuse_rgetworkingdir.c\
 unix/reuse_setlock.c\
 win32/reuse_setlock.c\
 unix/reuse_sleep.c\
 win32/reuse_sleep.c\
 unix/reuse_substsuffix.c\
 win32/reuse_substsuffix.c\
 unix/reuse_tempnam.c\
 win32/reuse_tempnam.c\
 ${COMMON_CFILES}\
 ${SUPER_CLNT_CFILES}\
 ${USERLIST_CLNT_CFILES}\
 ${NEW_SERVER_CLNT_CFILES}

HFILES=\
 ./include/ejudge/archive_paths.h\
 ./include/ejudge/avatar_plugin.h\
 ./include/ejudge/base32.h\
 ./include/ejudge/base64.h\
 ./include/ejudge/bitset.h\
 ./include/ejudge/bson_utils.h\
 ./include/ejudge/build_support.h\
 ./include/ejudge/cgi.h\
 ./include/ejudge/charsets.h\
 ./include/ejudge/cJSON.h\
 ./include/ejudge/clarlog.h\
 ./include/ejudge/clarlog_state.h\
 ./include/ejudge/cldb_plugin.h\
 ./include/ejudge/clntutil.h\
 ./include/ejudge/common_plugin.h\
 ./include/ejudge/compat.h\
 ./include/ejudge/compile_packet.h\
 ./include/ejudge/compile_packet_priv.h\
 ./include/ejudge/content_plugin.h\
 ./include/ejudge/contests.h\
 ./include/ejudge/copyright.h\
 ./include/ejudge/cpu.h\
 ./include/ejudge/cr_serialize.h\
 ./include/ejudge/csv.h\
 ./include/ejudge/curtime.h\
 ./include/ejudge/dates_config.h\
 ./include/ejudge/diff.h\
 ./include/ejudge/digest_io.h\
 ./include/ejudge/dwarf_parse.h\
 ./include/ejudge/ejudge_cfg.h\
 ./include/ejudge/ejudge_plugin.h\
 ./include/ejudge/ej_byteorder.h\
 ./include/ejudge/ej_import_packet.h\
 ./include/ejudge/ej_limits.h\
 ./include/ejudge/ej_process.h\
 ./include/ejudge/ej_types.h\
 ./include/ejudge/ej_libzip.h\
 ./include/ejudge/ej_uuid.h\
 ./include/ejudge/errlog.h\
 ./include/ejudge/expat_iface.h\
 ./include/ejudge/external_action.h\
 ./include/ejudge/filehash.h\
 ./include/ejudge/file_perms.h\
 ./include/ejudge/fileutl.h\
 ./include/ejudge/filter_eval.h\
 ./include/ejudge/filter_tree.h\
 ./include/ejudge/full_archive.h\
 ./include/ejudge/html.h\
 ./include/ejudge/html_parse.h\
 ./include/ejudge/http_request.h\
 ./include/ejudge/imagemagick.h\
 ./include/ejudge/internal_pages.h\
 ./include/ejudge/interrupt.h\
 ./include/ejudge/iterators.h\
 ./include/ejudge/job_packet.h\
 ./include/ejudge/l10n.h\
 ./include/ejudge/lang_config_vis.h\
 ./include/ejudge/list_ops.h\
 ./include/ejudge/meta_generic.h\
 ./include/ejudge/mime_type.h\
 ./include/ejudge/mischtml.h\
 ./include/ejudge/misctext.h\
 ./include/ejudge/ncheck_packet.h\
 ./include/ejudge/ncurses_utils.h\
 ./include/ejudge/new-server.h\
 ./include/ejudge/nsdb_plugin.h\
 ./include/ejudge/nwrun_packet.h\
 ./include/ejudge/opcaps.h\
 ./include/ejudge/packet_name.h\
 ./include/ejudge/parsecfg.h\
 ./include/ejudge/pathutl.h\
 ./include/ejudge/pollfds.h\
 ./include/ejudge/polygon_packet.h\
 ./include/ejudge/prepare.h\
 ./include/ejudge/prepare_dflt.h\
 ./include/ejudge/prepare_serve.h\
 ./include/ejudge/printing.h\
 ./include/ejudge/problem_common.h\
 ./include/ejudge/problem_config.h\
 ./include/ejudge/problem_xml.h\
 ./include/ejudge/process_stats.h\
 ./include/ejudge/protocol.h\
 ./include/ejudge/random.h\
 ./include/ejudge/rldb_plugin.h\
 ./include/ejudge/run.h\
 ./include/ejudge/runlog.h\
 ./include/ejudge/runlog_state.h\
 ./include/ejudge/run_packet.h\
 ./include/ejudge/run_packet_priv.h\
 ./include/ejudge/server_framework.h\
 ./include/ejudge/serve_state.h\
 ./include/ejudge/sformat.h\
 ./include/ejudge/shellcfg_parse.h\
 ./include/ejudge/sock_op.h\
 ./include/ejudge/startstop.h\
 ./include/ejudge/stringset.h\
 ./include/ejudge/super_clnt.h\
 ./include/ejudge/super_html.h\
 ./include/ejudge/super_proto.h\
 ./include/ejudge/super_run_packet.h\
 ./include/ejudge/super_run_status.h\
 ./include/ejudge/super-serve.h\
 ./include/ejudge/sha.h\
 ./include/ejudge/sha256.h\
 ./include/ejudge/sha256utils.h\
 ./include/ejudge/blowfish.h\
 ./include/ejudge/t3m_dir_listener.h\
 ./include/ejudge/t3m_packet_class.h\
 ./include/ejudge/t3m_submits.h\
 ./include/ejudge/t3_packets.h\
 ./include/ejudge/teamdb.h\
 ./include/ejudge/teamdb_priv.h\
 ./include/ejudge/team_extra.h\
 ./include/ejudge/testinfo.h\
 ./include/ejudge/testing_report_xml.h\
 ./include/ejudge/tex_dom.h\
 ./include/ejudge/timestamp.h\
 ./include/ejudge/tsc.h\
 ./include/ejudge/type_info.h\
 ./include/ejudge/uldb_plugin.h\
 ./include/ejudge/userlist.h\
 ./include/ejudge/userlist_bin.h\
 ./include/ejudge/userlist_clnt.h\
 ./include/ejudge/variant_map.h\
 ./include/ejudge/varsubst.h\
 ./include/ejudge/vcs.h\
 ./include/ejudge/version.h\
 ./include/ejudge/watched_file.h\
 ./include/ejudge/win32_compat.h\
 unix/unix_fileutl.h\
 userlist_clnt/private.h\
 ./include/ejudge/new_server_clnt.h\
 ./include/ejudge/new_server_proto.h\
 new_server_clnt/new_server_clnt_priv.h\
 ./include/ejudge/xml_utils.h\
 ./include/ejudge/xuser_plugin.h\
 ./include/ejudge/zip_utils.h

OTHERFILES=\
 filter_expr.y\
 filter_scan.lex\
 plugins/mysql-userlist/uldb_mysql.c
